//---CREDITS
// Name: libralis.cpp
// Comp: Visual C++ .NET
//------------------------->


//---INCLUDES
// "libralis.h" 
//---------------------------------------------------------------->
#include "libralis.h"
	
EstimateClass hEstimateTable;  
CompensationClass hCompensationTable;  
static int nVertexNumb;  
static float fSide;  
static Vect3Float fv3Max_WS;  
static Vect3Float fv3Min_WS;  
Vect3Float ProbePose;  
Vect3Float CompensationTerm;  
static bool Initialized = false;


// ***** Replace return and argument types to fit the desired API
//
//
Vector3 Compensate(Vector3 position)
{
	if (Initialized)
	{
		ProbePose.x = position.x;
		ProbePose.y = position.y;
		ProbePose.z = position.z;

		CompensationTerm = gravityCompensation(ProbePose, fv3Max_WS, fv3Min_WS, &hCompensationTable, &hEstimateTable, fSide).gravity;
	}
	else 
	{
		CompensationTerm.x = 0.0f;
		CompensationTerm.y = 0.0f;
		CompensationTerm.z = 0.0f;
	}

	// ***** Replace here the return type
	return Vector3(CompensationTerm.x, CompensationTerm.y, CompensationTerm.z);
	
}
	

bool InitLibralis()
{
	
	// Generating the name of the file, with extension, for Estimation:
	string *F_FileEstimation = new string(GRAVITY_COMPENSATION_FILE);	
	F_FileEstimation->append(std::string(".dat"));

	// Generating the name of the file, with extension, for Compensation:
	std::string *F_FileCompensation = new std::string(GRAVITY_COMPENSATION_FILE);
	F_FileCompensation->append(std::string(".001"));
		
	// Read the estimations from file:
	bool EstimationFileExists = hEstimateTable.readEstimateFromFile(F_FileEstimation->c_str(), &nVertexNumb, &fSide);
	
	// Read the compensation from file:
	bool CompensationFileExists =hCompensationTable.readCompensationFromFile(F_FileCompensation->c_str(), nVertexNumb);

	// Dimension of max workspace vertex:
	fv3Max_WS.x = fSide * hEstimateTable.dimGrid_max.x;
	fv3Max_WS.y = fSide * hEstimateTable.dimGrid_max.y;
	fv3Max_WS.z = fSide * hEstimateTable.dimGrid_max.z;

	// Dimension of min workspace vertex: 
	fv3Min_WS.x = fSide * hEstimateTable.dimGrid_min.x;
	fv3Min_WS.y = fSide * hEstimateTable.dimGrid_min.y;
	fv3Min_WS.z = fSide * hEstimateTable.dimGrid_min.z;

	// The gravity compensation is enabled only if both files were correctly read
	if ((EstimationFileExists) && (CompensationFileExists))
	{
		Initialized = true;
		return true;
	}
	else 
	{
		Initialized = false;
		return false;
	}
} // void InitGravityCompensation




